TidyPlatesThreat = LibStub("AceAddon-3.0"):NewAddon("TidyPlatesThreat", "AceConsole-3.0","AceEvent-3.0")
local Media = LibStub("LibSharedMedia-3.0")
local DataBroker = LibStub:GetLibrary("LibDataBroker-1.1",true)
local path = "Interface\\Addons\\TidyPlates_ThreatPlates\\Artwork\\"
local classicon = "Interface\\Addons\\TidyPlates_ThreatPlates\\Artwork\\class\\"

--[[Set MultiStyle]]--
if not TidyPlatesThemeList then TidyPlatesThemeList = {} end
TidyPlatesThemeList["ThreatPlates"] = {}

--[[Options and Default Settings]]--
function TidyPlatesThreat:OnInitialize()
	local options = { 
		type = "group", 
		args = {
			OptionsDescription = {
				type = "description",
				order = 1,
				name = "Clear and easy to use nameplate theme for use with TidyPlates.\nFeel free to email me at |cff00ff00Shamtasticle@gmail.com|r\nSyronius, of Black Dragonflight - US <Fallout>",
			},
--[[Options Frames]]--
			OptionsHeader = {
				order = 2,
				type = "header",
				name = "Tidy Plates: Threat Plates v1.8",
			},
			NameplateOptFrame = {
		        order = 3,
		        type  = "group",
       			name  = "Nameplate Options",
		        args = {
					description = {
						type = "description",
						order = 1,
						name = "Toggle the showing and hiding of nameplates.",
					},
					ShowNeutral = {
						type = "toggle",
						order = 2,
						name = "Show Neutral",
						get = function() return self.db.profile.nameplate.toggle["Neutral"] end,
						set = function(info,val) 
							self.db.profile.nameplate.toggle["Neutral"] = not self.db.profile.nameplate.toggle["Neutral"]
							if self.db.profile.nameplate.toggle["Neutral"] then return print("-->>Neutral nameplates are now |cff00ff00ON!|r<<--") else return print("-->>Neutral nameplates are now |cffff0000OFF!|r<<--") end
						end
					},
					ShowNormal = {
						type = "toggle",
						order = 3,
						name = "Show Normal",
						get = function() return self.db.profile.nameplate.toggle["Normal"] end,
						set = function(info,val) 
							self.db.profile.nameplate.toggle["Normal"] = not self.db.profile.nameplate.toggle["Normal"]
							if self.db.profile.nameplate.toggle["Normal"] then return print("-->>Normal nameplates are now |cff00ff00ON!|r<<--") else return print("-->>Normal nameplates are now |cffff0000OFF!|r<<--") end
						end
					},
					ShowElite = {
						type = "toggle",
						order = 4,
						name = "Show Elite",
						get = function() return self.db.profile.nameplate.toggle["Elite"] end,
						set = function(info,val) 
							self.db.profile.nameplate.toggle["Elite"] = not self.db.profile.nameplate.toggle["Elite"]
							if self.db.profile.nameplate.toggle["Elite"] then return print("-->>Elite nameplates are now |cff00ff00ON!|r<<--") else return print("-->>Elite nameplates are now |cffff0000OFF!|r<<--") end
						end
					},
					ShowBoss = {
						type = "toggle",
						order = 5,
						name = "Show Boss",
						get = function() return self.db.profile.nameplate.toggle["Boss"] end,
						set = function(info,val) 
							self.db.profile.nameplate.toggle["Boss"] = not self.db.profile.nameplate.toggle["Boss"]
							if self.db.profile.nameplate.toggle["Boss"] then return print("-->>Boss nameplates are now |cff00ff00ON!|r<<--") else return print("-->>Boss nameplates are now |cffff0000OFF!|r<<--") end
						end
					},
					Scale = {
						type = "group",
						order = 6,
						name = "Nameplate Scale",
						desc = "Set nameplate scale levels",
						args = {
							levels = {
								type = "header",
								order = 3,
								name = "Nameplate Scale Levels",
							},
							Neutral_scale = {
								type 	= "range",
								order 	= 4,
								name 	= "Neutral Scale",
								get 	= function(info) return self.db.profile.nameplate.scale["Neutral"] end,
								set 	= function(info,v)
											self.db.profile.nameplate.scale["Neutral"] = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 2,
								isPercent = true,
							},
							Normal_scale = {
								type 	= "range",
								order 	= 5,
								name 	= "Normal Scale",
								get 	= function(info) return self.db.profile.nameplate.scale["Normal"] end,
								set 	= function(info,v)
											self.db.profile.nameplate.scale["Normal"] = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 2,
								isPercent = true,
							},
							Elite_scale = {
								type 	= "range",
								order 	= 6,
								name 	= "Elite Scale",
								get 	= function(info) return self.db.profile.nameplate.scale["Elite"] end,
								set 	= function(info,v)
											self.db.profile.nameplate.scale["Elite"] = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 2,
								isPercent = true,
							},
							Boss_scale = {
								type 	= "range",
								order 	= 7,
								name 	= "Boss Scale",
								get 	= function(info) return self.db.profile.nameplate.scale["Boss"] end,
								set 	= function(info,v)
											self.db.profile.nameplate.scale["Boss"] = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 2,
								isPercent = true,
							},
						},
					},
					Alpha = {
						type = "group",
						order = 7,
						name = "Nameplate Alpha",
						desc = "Set nameplate alpha levels",
						args = {
							levels = {
								type = "header",
								order = 3,
								name = "Nameplate Alpha Levels",
							},
							Neutral_alpha = {
								type 	= "range",
								order 	= 4,
								name 	= "Neutral alpha",
								get 	= function(info) return self.db.profile.nameplate.alpha["Neutral"] end,
								set 	= function(info,v)
											self.db.profile.nameplate.alpha["Neutral"] = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 1,
								isPercent = true,
							},
							Normal_alpha = {
								type 	= "range",
								order 	= 5,
								name 	= "Normal alpha",
								get 	= function(info) return self.db.profile.nameplate.alpha["Normal"] end,
								set 	= function(info,v)
											self.db.profile.nameplate.alpha["Normal"] = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 1,
								isPercent = true,
							},
							Elite_alpha = {
								type 	= "range",
								order 	= 6,
								name 	= "Elite alpha",
								get 	= function(info) return self.db.profile.nameplate.alpha["Elite"] end,
								set 	= function(info,v)
											self.db.profile.nameplate.alpha["Elite"] = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 1,
								isPercent = true,
							},
							Boss_alpha = {
								type 	= "range",
								order 	= 7,
								name 	= "Boss alpha",
								get 	= function(info) return self.db.profile.nameplate.alpha["Boss"] end,
								set 	= function(info,v)
											self.db.profile.nameplate.alpha["Boss"] = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 1,
								isPercent = true,
							},
						},
					},
				},
			},
			TextOptFrame = {
		        order = 4,
		        type  = "group",
       			name  = "Text Options",
		        args = {
					TextOptHeader = {
						order = 1,
						type = "header",
						name = "Text Options",
					},
					hptextdesc = {
						order = 2,
						type = "description",
						name = "\nHP Special Text is the center text displaying the truncated HP amount and HP percentage on nameplates.\n",
					},
					hptext = {
						order = 3,
						type = "toggle",
						name = "Show HP Special Text",
						desc = "Toggles the showing and hiding of HP Special Text",
						get = function() return self.db.profile.text.hptext end,
						set = function(info,val) 
							self.db.profile.text.hptext = not self.db.profile.text.hptext
							if self.db.profile.text.hptext then return print("-->>HP Special Text is now |cff00ff00ON!|r<<--") else return print("-->>HP Special Text is now |cffff0000OFF!|r<<--") end
						end
					},
					casttext = {
						order = 5,
						type = "toggle",
						name = "Show Spell Cast Text",
						desc = "Toggles the showing and hiding of Spell Cast Text",
						get = function() return self.db.profile.text.cast end,
						set = function(info,val) 
							self.db.profile.text.cast = not self.db.profile.text.cast
							if self.db.profile.text.cast then return print("-->>Spell Cast Text is now |cff00ff00ON!|r<<--") else return print("-->>Spell Cast Text is now |cffff0000OFF!|r<<--") end
						end
					},
					formatheader = {
						order = 6,
						type = "header",
						name = "Text Formatting"
					},
					fullhp = {
						order = 7,
						type = "toggle",
						name = "Show HP at full",
						desc = "Display HP when a unit is at 100%.",
						get = function() return self.db.profile.text.full end,
						set = function(info,val)
							self.db.profile.text.full = not self.db.profile.text.full
							if self.db.profile.text.full then return print("-->>Full HP Text is now |cff00ff00ON!|r<<--") else return print("-->>Full HP Text is now |cffff0000OFF!|r<<--") end
						end
					},
					hpamount = {
						order = 8,
						type = "toggle",
						name = "Show HP Amount",
						desc = "Display HP amount number text.",
						get = function() return self.db.profile.text.amount end,
						set = function(info,val)
							self.db.profile.text.amount = not self.db.profile.text.amount
							if self.db.profile.text.amount then return print("-->>HP Text Amount is now |cff00ff00ON!|r<<--") else return print("-->>HP Text Amount is now |cffff0000OFF!|r<<--") end
						end
					},
					hptruncate = {
						order = 9,
						type = "toggle",
						name = "Truncate HP Amount",
						desc = "Truncate HP amount number text to simplified millions and thousands.",
						get = function() return self.db.profile.text.truncate end,
						set = function(info,val)
							self.db.profile.text.truncate = not self.db.profile.text.truncate
							if self.db.profile.text.truncate then return print("-->>HP Text Amount truncation is now |cff00ff00ON!|r<<--") else return print("-->>HP Text Amount truncation is now |cffff0000OFF!|r<<--") end
						end
					},
					hpdeficit = {
						order = 10,
						type = "toggle",
						name = "Deficit HP Amount",
						desc = "Deficit HP amount to show a negative value of HP.",
						get = function() return self.db.profile.text.deficit end,
						set = function(info,val)
							self.db.profile.text.deficit = not self.db.profile.text.deficit
							if self.db.profile.text.deficit then return print("-->>Deficit HP Text Amount is now |cff00ff00ON!|r<<--") else return print("-->>Deficit HP Text Amount is now |cffff0000OFF!|r<<--") end
						end
					},
					extrasheader = {
						order = 11,
						type = "header",
						name = "Text Extras"
					},
					hp_percent = {
						order = 12,
						type = "toggle",
						name = "Show HP Percent",
						desc = "Display HP Percent text.",
						get = function() return self.db.profile.text.percent end,
						set = function(info,val)
							self.db.profile.text.percent = not self.db.profile.text.percent
							if self.db.profile.text.percent then 
								return print("-->>HP Percentage Text is now |cff00ff00ON!|r<<--") else return print("-->>HP Percentage Text is now |cffff0000OFF!|r<<--") end
						end
					},
					hpmax = {
						order = 13,
						type = "toggle",
						name = "Show HP Maximum",
						desc = "Display HP Max Value text.",
						get = function() return self.db.profile.text.max end,
						set = function(info,val)
							self.db.profile.text.max = not self.db.profile.text.max
							if self.db.profile.text.max then return print("-->>HP Maximum Text is now |cff00ff00ON!|r<<--") else return print("-->>HP Maximum Text is now |cffff0000OFF!|r<<--") end
						end
					},
				},
			},
			ThreatOptFrame = {
		        order = 5,
		        type  = "group",
       			name  = "Threat Options",
		        args = {
					ThreatDescription = {
						type = "description",
						order = 1,
						name = "Toggle the threat system on or off",
					},
					threat = {
						order = 2,
						type = "toggle",
						name = "Enable Threat System",
						desc = "Enable or disable the threat plates system.",
						get = function() return self.db.profile.threat.ON end,
						set = function(info,val) 
							self.db.profile.threat.ON = not self.db.profile.threat.ON
							if self.db.profile.threat.ON then return print("-->>|cff00ff00Threat System is now ON!|r<<--") else return print("-->>|cffff0000Threat System is now OFF!|r<<--") end
						end
					},
					RoleDescription = {
						type = "description",
						order = 4,
						name = "Select which role you're currently fulfilling.",
					},
					DPSRole = {
						order = 5,
						type = "toggle",
						name = "DPS Role",
						desc = "Enable or disable the threat plates system for DPSing.",
						get = function() return not self.db.profile.threat.tanking end,
						set = function(info,val) 
								self.db.profile.threat.tanking = false
								self.db.profile.threat.ON = true
								print("-->>|cff00ff00DPS Role threat system is now active!!|r<<--")
							end
					},
					TankRole = {
						order = 6,
						type = "toggle",
						name = "Tank Role",
						desc = "Enable or disable the threat plates system for Tanking.",
						get = function() return self.db.profile.threat.tanking end,
						set = function(info,val) 
								self.db.profile.threat.tanking = true
								self.db.profile.threat.ON = true
								print("-->>|cff00ff00Tank Role threat system is now active!!|r<<--")
							end
					},
					AdditionalToggles = {
						order = 7,
						type = "header",
						name = "Additional Toggles",
					},
					Boss_Threat = {
						order = 11,
						type = "toggle",
						name = "Show Boss Threat",
						desc = "Enable or disable the threat plates system for Boss units.",
						get = function() return self.db.profile.threat.toggle["Boss"] end,
						set = function(info,val) 
							self.db.profile.threat.toggle["Boss"] = not self.db.profile.threat.toggle["Boss"]
							if self.db.profile.threat.toggle["Boss"] then return print("-->>|cff00ff00Boss Threat System is now ON!|r<<--") else return print("-->>|cffff0000Boss Threat System is now OFF!|r<<--") end
						end
					},
					Elite_Threat = {
						order = 10,
						type = "toggle",
						name = "Show Elite Threat",
						desc = "Enable or disable the threat plates system for Elite units.",
						get = function() return self.db.profile.threat.toggle["Elite"] end,
						set = function(info,val) 
							self.db.profile.threat.toggle["Elite"] = not self.db.profile.threat.toggle["Elite"]
							if self.db.profile.threat.toggle["Elite"] then return print("-->>|cff00ff00Elite Threat System is now ON!|r<<--") else return print("-->>|cffff0000Elite Threat System is now OFF!|r<<--") end
						end
					},
					Normal_Threat = {
						order = 9,
						type = "toggle",
						name = "Show Normal Threat",
						desc = "Enable or disable the threat plates system for Normal units.",
						get = function() return self.db.profile.threat.toggle["Normal"] end,
						set = function(info,val) 
							self.db.profile.threat.toggle["Normal"]  = not self.db.profile.threat.toggle["Normal"] 
							if self.db.profile.threat.toggle["Normal"]  then return print("-->>|cff00ff00Normal Threat System is now ON!|r<<--") else return print("-->>|cffff0000Normal Threat System is now OFF!|r<<--") end
						end
					},
					Neutral_Threat = {
						order = 8,
						type = "toggle",
						name = "Show Neutral Threat",
						desc = "Enable or disable the threat plates system for Neutral units.",
						get = function() return self.db.profile.threat.toggle["Neutral"]  end,
						set = function(info,val) 
							self.db.profile.threat.toggle["Neutral"] = not self.db.profile.threat.toggle["Neutral"]
							if self.db.profile.threat.toggle["Neutral"] then return print("-->>|cff00ff00Neutral Threat System is now ON!|r<<--") else return print("-->>|cffff0000Neutral Threat System is now OFF!|r<<--") end
						end
					},
					DPS = {
						name = "|cffffffffDPS Threat Levels|r",
						type = "group",
						desc = "Set threat scales and alpha for DPSing",
						order = 1,
						args = {
							scaleheader = {
								type = "header",
								order = 1,
								name = "Nameplate Scale",
							},
							lowthreat = {
								type 	= "range",
								order 	= 2,
								name 	= "|cff00ff00Low Threat Scale|r",
								get 	= function(info) return self.db.profile.threat.dps.scale.LOW end,
								set 	= function(info,v)
											self.db.profile.threat.dps.scale.LOW = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 2,
								isPercent = true,
							},
							medthreat = {
								type 	= "range",
								order 	= 3,
								name 	= "|cffffff00Medium Threat Scale|r",
								get 	= function(info) return self.db.profile.threat.dps.scale.MEDIUM end,
								set 	= function(info,v)
											self.db.profile.threat.dps.scale.MEDIUM = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 2,
								isPercent = true,
							},
							highthreat = {
								type 	= "range",
								order 	= 4,
								name 	= "|cffff0000High Threat Scale|r",
								get 	= function(info) return self.db.profile.threat.dps.scale.HIGH end,
								set 	= function(info,v)
											self.db.profile.threat.dps.scale.HIGH = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 2,
								isPercent = true,
							},
							alphaheader = {
								type = "header",
								order = 5,
								name = "Nameplate Alpha",
							},
							alphalow = {
								type 	= "range",
								order 	= 7,
								name 	= "|cff00ff00Low Threat Alpha|r",
								get 	= function(info) return self.db.profile.threat.dps.alpha.LOW end,
								set 	= function(info,v)
											self.db.profile.threat.dps.alpha.LOW = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 1,
								isPercent = true,
							},
							alphaMed = {
								type 	= "range",
								order 	= 8,
								name 	= "|cffffff00Medium Threat Alpha|r",
								get 	= function(info) return self.db.profile.threat.dps.alpha.MEDIUM end,
								set 	= function(info,v)
											self.db.profile.threat.dps.alpha.MEDIUM = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 1,
								isPercent = true,
							},
							alphahigh = {
								type 	= "range",
								order 	= 9,
								name 	= "|cffff0000High Threat Alpha|r",
								get 	= function(info) return self.db.profile.threat.dps.alpha.HIGH end,
								set 	= function(info,v)
											self.db.profile.threat.dps.alpha.HIGH = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 1,
								isPercent = true,
							},
						},
					},
					Tank = {
						name = "|cffffffffTank Threat Levels|r",
						type = "group",
						desc = "Set threat scales and alpha for Tanking",
						order = 2,
						args = {
							tankdesc = {
								type = "header",
								order = 1,
								name = "Nameplate Scale",
							},
							lowthreat = {
								type 	= "range",
								order 	= 2,
								name 	= "|cffff0000Low Threat Scale|r",
								get 	= function(info) return self.db.profile.threat.tank.scale.LOW end,
								set 	= function(info,v)
											self.db.profile.threat.tank.scale.LOW = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 2,
								isPercent = true,
							},
							medthreat = {
								type 	= "range",
								order 	= 3,
								name 	= "|cffffff00Medium Threat Scale|r",
								get 	= function(info) return self.db.profile.threat.tank.scale.MEDIUM end,
								set 	= function(info,v)
											self.db.profile.threat.tank.scale.MEDIUM = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 2,
								isPercent = true,
							},
							highthreat = {
								type 	= "range",
								order 	= 4,
								name 	= "|cff00ff00High Threat Scale|r",
								get 	= function(info) return self.db.profile.threat.tank.scale.HIGH end,
								set 	= function(info,v)
											self.db.profile.threat.tank.scale.HIGH = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 2,
								isPercent = true,
							},
							alphaheader = {
								type = "header",
								order = 5,
								name = "Nameplate Alpha",
							},
							alphalow = {
								type 	= "range",
								order 	= 7,
								name 	= "|cffff0000Low Threat Alpha|r",
								get 	= function(info) return self.db.profile.threat.tank.alpha.LOW end,
								set 	= function(info,v)
											self.db.profile.threat.tank.alpha.LOW = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 1,
								isPercent = true,
							},
							alphaMed = {
								type 	= "range",
								order 	= 8,
								name 	= "|cffffff00Medium Threat Alpha|r",
								get 	= function(info) return self.db.profile.threat.tank.alpha.MEDIUM end,
								set 	= function(info,v)
											self.db.profile.threat.tank.alpha.MEDIUM = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 1,
								isPercent = true,
							},
							alphahigh = {
								type 	= "range",
								order 	= 9,
								name 	= "|cff00ff00High Threat Alpha|r",
								get 	= function(info) return self.db.profile.threat.tank.alpha.HIGH end,
								set 	= function(info,v)
											self.db.profile.threat.tank.alpha.HIGH = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 1,
								isPercent = true,
							},
						},
					},
					Marked = {
						name = "|cffffffffMarked Units|r",
						type = "group",
						desc = "Set threat textures, scales, and alpha for marked units.",
						order = 3,
						args = {
							header1 = {
								order = 1,
								type = "header",
								name = "Marked Mob Ignore Settings"
							},
							descript1 = {
								order = 2,
								type = "description",
								name = "Threat textures, scaling, and alpha changes can be ignored for units that are marked."
							},
							art = {
								order = 3,
								name = "Remove Threat Textures",
								type = "toggle",
								desc = "Disables all threat textures for marked units.",
								get = function() return self.db.profile.threat.marked.art end,
								set = function(info,val) 
									self.db.profile.threat.marked.art = not self.db.profile.threat.marked.art
									if self.db.profile.threat.marked.art then return print("-->>Ignoring of marked unit threat textures is now |cff00ff00ON!|r<<--") else return print("-->>Ignoring of marked unit threat textures is now |cffff0000OFF!|r<<--") end
								end
							},
							alpha = {
								order = 4,
								name = "Remove Threat Alpha",
								type = "toggle",
								desc = "Disables all threat alpha settings for marked units.",
								get = function() return self.db.profile.threat.marked.alpha end,
								set = function(info,val) 
									self.db.profile.threat.marked.alpha = not self.db.profile.threat.marked.alpha
									if self.db.profile.threat.marked.alpha then return print("-->>Ignoring of marked unit threat alpha is now |cff00ff00ON!|r<<--") else return print("-->>Ignoring of marked unit threat alpha is now |cffff0000OFF!|r<<--") end
								end
							},
							scale = {
								order = 4,
								name = "Remove Threat Scale",
								type = "toggle",
								desc = "Disables all threat scale settings for marked units.",
								get = function() return self.db.profile.threat.marked.scale end,
								set = function(info,val) 
									self.db.profile.threat.marked.scale = not self.db.profile.threat.marked.scale
									if self.db.profile.threat.marked.scale then return print("-->>Ignoring of marked unit threat scale is now |cff00ff00ON!|r<<--") else return print("-->>Ignoring of marked unit threat scale is now |cffff0000OFF!|r<<--") end
								end
							},
						},
					},
				},
			},
		},
	}
	local defaults 	= {
		profile = {
			text = {
				amount = true,
				cast = true,
				deficit = false,
				full = false,
				hptext = true,
				max = false,
				percent = true,
				truncate = true		
			},
			threat = {
				ON = true,
				marked = false,
				tanking = true,
				toggle = {
					["Boss"]	= true,
					["Elite"]	= true,
					["Normal"]	= true,
					["Neutral"]	= true
				},
				dps = {
					scale = {
						LOW 		= 0.8,
						MEDIUM		= 0.9,
						HIGH 		= 1.25
					},
					alpha = {
						LOW 		= 1,
						MEDIUM		= 1,
						HIGH 		= 1
					},
				},
				tank = {
					scale = {
						LOW 		= 1.25,
						MEDIUM		= 0.9,
						HIGH 		= 0.8
					},
					alpha = {
						LOW 		= 1,
						MEDIUM		= 0.85,
						HIGH 		= 0.75
					},
				},
				marked = {
					alpha = false,
					art = false,
					scale = false					
				},
			},
			
			nameplate = {
				toggle = {
					["Boss"]	= true,
					["Elite"]	= true,
					["Normal"]	= true,
					["Neutral"]	= true
				},
				scale = {
					["Boss"]	= 1,
					["Elite"]	= 1,
					["Normal"]	= 0.9,
					["Neutral"]	= 0.8
				},
				alpha = {
					["Boss"]	= 1,
					["Elite"]	= 1,
					["Normal"]	= 0.9,
					["Neutral"]	= 0.8
				},
			},
		}
    }
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Tidy Plates: Threat Plates Options:", options)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Tidy Plates: Threat Plates Options:", "Tidy Plates: Threat Plates")
	self:RegisterChatCommand("tptp", function () InterfaceOptionsFrame_OpenToCategory(self.optionsFrame) end)
	self.message = "Welcome to Tidy Plates: Threat Plates!"
	self.db = LibStub("AceDB-3.0"):New("ThreatPlatesDB", defaults)
	print(self.message)
end
--[[TPTP Tank Toggle Command]]--
local function TPTPTANK()
	TidyPlatesThreat.db.profile.threat.tanking = true
	print("-->>|cff00ff00Tank Plates Enabled|r<<--")
end
SLASH_TPTPTANK1 = "/tptptank"
SlashCmdList["TPTPTANK"] = TPTPTANK

--[[TPTP DPS Toggle Command]]--
local function TPTPDPS()
	TidyPlatesThreat.db.profile.threat.tanking = false
	print("-->>|cffff0000DPS Plates Enabled|r<<--")
end
SLASH_TPTPDPS1 = "/tptpdps"
SlashCmdList["TPTPDPS"] = TPTPDPS

--[[TPTP Role Toggle Command]]--

local function TPTPTOGGLE()
	TidyPlatesThreat.db.profile.threat.tanking = not TidyPlatesThreat.db.profile.threat.tanking
	if TidyPlatesThreat.db.profile.threat.tanking then 
		return print("-->>|cff00ff00Tank Plates Enabled|r<<--")
	else
		return print("-->>|cffff0000DPS Plates Enabled|r<<--")
	end
end
SLASH_TPTPTOGGLE1 = "/tptptoggle"
SlashCmdList["TPTPTOGGLE"] = TPTPTOGGLE


local function SetStyle(unit)
	local unitRank
	if (unit.isDangerous and (unit.reaction == "FRIENDLY" or unit.reaction == "HOSTILE")) then
		unitRank = "Boss"
	elseif (unit.isElite and not unit.isDangerous and (unit.reaction == "FRIENDLY" or unit.reaction == "HOSTILE")) then
		unitRank = "Elite"
	elseif (not unit.isElite and not unit.isDangerous and (unit.reaction == "FRIENDLY" or unit.reaction == "HOSTILE"))then
		unitRank = "Normal"
	elseif unit.reaction == "NEUTRAL" then
		unitRank = "Neutral"
	end
	if unit.reaction == "HOSTILE" or unit.reaction == "NEUTRAL" then
		if TidyPlatesThreat.db.profile.nameplate.toggle[unitRank] then
			if TidyPlatesThreat.db.profile.threat.toggle[unitRank] and TidyPlatesThreat.db.profile.threat.ON and InCombatLockdown() then
				if TidyPlatesThreat.db.profile.threat.tanking then
					return "tank"
				else
					return "dps"
				end
			else 
				return "normal"
			end
		else
			return "empty"
		end
	elseif unit.reaction == "FRIENDLY" then
		if TidyPlatesThreat.db.profile.nameplate.toggle[unitRank] then
			return "normal"
		else
			return "empty"
		end
	else 
		return "empty"
	end
end

local Truncate = function(value)
	if TidyPlatesThreat.db.profile.text.truncate then
		if value >= 1e6 then
			return format('%.1fm', value / 1e6)
		elseif value >= 1e4 then
			return format('%.1fk', value / 1e3)
		else
			return value
		end
	else 
		return value
	end
end

function SetSpecialText(unit)
	local HpPct
	local HpAmt
	local HpMax
	if TidyPlatesThreat.db.profile.text.percent then
		if (TidyPlatesThreat.db.profile.text.amount or TidyPlatesThreat.db.profile.text.max) then
			if TidyPlatesThreat.db.profile.text.deficit and not TidyPlatesThreat.db.profile.text.max and unit.health == unit.healthmax then
				HpPct = floor(100*(unit.health / unit.healthmax)).."%"
			else
				HpPct = " - "..floor(100*(unit.health / unit.healthmax)).."%"
			end
		else
			HpPct = floor(100*(unit.health / unit.healthmax)).."%"
		end
	else
		HpPct = ""
	end
	if TidyPlatesThreat.db.profile.text.amount then
		if TidyPlatesThreat.db.profile.text.deficit then
			if (unit.health == unit.healthmax) then
				HpAmt = ""
			else
				HpAmt = "-"..Truncate(unit.healthmax - unit.health)
			end
		else
			HpAmt = Truncate(unit.health)
		end
	else HpAmt = ""
	end
	if TidyPlatesThreat.db.profile.text.max then
		if TidyPlatesThreat.db.profile.text.amount then
			if TidyPlatesThreat.db.profile.text.deficit and unit.health == unit.healthmax then
				HpMax = Truncate (unit.healthmax)
			else
				HpMax = " / "..Truncate(unit.healthmax)
			end
		else 
			HpMax = Truncate(unit.healthmax)
		end
	else 
		HpMax = ""
	end
	if TidyPlatesThreat.db.profile.text.hptext then
		if (unit.health / unit.healthmax) < 1 then
			return HpAmt..HpMax..HpPct
		else
			if TidyPlatesThreat.db.profile.text.full then
				return HpAmt..HpMax..HpPct
			else 
				return ""
			end
		end
	else 
		return ""
	end
end

function SetSpecialText2(unit)
	if TidyPlatesThreat.db.profile.text.cast then
		local spellname
		if unit.isCasting then 
			spellname = UnitCastingInfo("target") or UnitChannelInfo("target")
			return spellname
		else return ""
		end
	end
end

function SetSpecialArt(unit)
	if SetStyle(unit) == "tank" or SetStyle(unit) == "dps" and InCombatLockdown() and unit.class == "UNKNOWN" then
		if unit.isMarked and TidyPlatesThreat.db.profile.threat.marked.art then
			return nil
		else
			return path..SetStyle(unit).."\\"..unit.threatSituation
		end
	elseif unit.class and (unit.class ~= "UNKNOWN") then
		return classicon..unit.class
	else
		return nil
	end
end

local function SetScale(unit)
	local unitRank
	if (unit.isDangerous and (unit.reaction == "FRIENDLY" or unit.reaction == "HOSTILE")) then
		unitRank = "Boss"
	elseif (unit.isElite and not unit.isDangerous and (unit.reaction == "FRIENDLY" or unit.reaction == "HOSTILE")) then
		unitRank = "Elite"
	elseif (not unit.isElite and not unit.isDangerous and (unit.reaction == "FRIENDLY" or unit.reaction == "HOSTILE"))then
		unitRank = "Normal"
	elseif unit.reaction == "NEUTRAL" then
		unitRank = "Neutral"
	end
	if SetStyle(unit) == "normal" then
		return TidyPlatesThreat.db.profile.nameplate.scale[unitRank]
	elseif SetStyle(unit) == "tank" or SetStyle(unit) == "dps" then
		if unit.isMarked and TidyPlatesThreat.db.profile.threat.marked.scale then
			return TidyPlatesThreat.db.profile.nameplate.scale[unitRank]
		else
			return TidyPlatesThreat.db.profile.threat[SetStyle(unit)].scale[unit.threatSituation]
		end
	else 
		return 1
	end
end

local function SetAlpha(unit)
	local unitRank
	if (unit.isDangerous and (unit.reaction == "FRIENDLY" or unit.reaction == "HOSTILE")) then
		unitRank = "Boss"
	elseif (unit.isElite and not unit.isDangerous and (unit.reaction == "FRIENDLY" or unit.reaction == "HOSTILE")) then
		unitRank = "Elite"
	elseif (not unit.isElite and not unit.isDangerous and (unit.reaction == "FRIENDLY" or unit.reaction == "HOSTILE"))then
		unitRank = "Normal"
	elseif unit.reaction == "NEUTRAL" then
		unitRank = "Neutral"
	end
	if SetStyle(unit) == "normal" then
		return TidyPlatesThreat.db.profile.nameplate.alpha[unitRank]
	elseif SetStyle(unit) == "tank" or SetStyle(unit) == "dps" then
		if unit.isMarked and TidyPlatesThreat.db.profile.threat.marked.alpha then
			return TidyPlatesThreat.db.profile.nameplate.alpha[unitRank]
		else
			return TidyPlatesThreat.db.profile.threat[SetStyle(unit)].alpha[unit.threatSituation]
		end
	else 
		return 1
	end
end

		
TidyPlatesThemeList["ThreatPlates"].SetStyle = SetStyle
TidyPlatesThemeList["ThreatPlates"].SetScale = SetScale
TidyPlatesThemeList["ThreatPlates"].SetAlpha = SetAlpha
TidyPlatesThemeList["ThreatPlates"].SetSpecialText = SetSpecialText
TidyPlatesThemeList["ThreatPlates"].SetSpecialText2 = SetSpecialText2
TidyPlatesThemeList["ThreatPlates"].SetSpecialArt = SetSpecialArt

--[[Auto Settings]]--
SetCVar("threatWarning", 3)
SetCVar("nameplateShowEnemies", 1)
SetCVar("ShowClassColorInNameplate", 1)
TidyPlates:UseAutoHide(false)